#!/usr/bin/env python2.4

# usage: convert.py input.txt [ toplevel_outdir ]
#
# converts a Q&A format text file into the directory structure
# used by the python supermemox.
#
#
#
#   Robert W. Brewer <rwb123@gmail.com>
#   Copyright (C) 2004 Robert W. Brewer
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


import os
import re
import sys


class Item:
  def __init__(self, items, cat):
    self.items = items
    self.cat = cat
    print items, cat


all_items = []

cur_cat = ''
cur_item = []

def finish_item():
  global cur_item, cur_cat
  print 'finish_item'
  if cur_item:
    all_items.append(Item(cur_item, cur_cat))
  cur_item = []
  cur_cat = ''

def finish_or_add(index, val):
  global cur_item
  if len(cur_item) > index:
    print 'len ', len(cur_item), ' index ', index
    finish_item()
  cur_item += ['' for i in range(index + 1 - len(cur_item))]
  cur_item[index] = val
  print 'cur_item ', cur_item

# suck in and parse the input file
for l in file(sys.argv[1], 'r').readlines():
  if re.match('/', l):  # skip comments
    continue
  if re.match(r'\s*$', l):  # skip whitespace
    continue

  m = re.match(r'([cCqQaA123456]):(.*)', l)
  if m:
    if m.group(1) in 'cC': # category
      finish_item()
      cur_cat = m.group(2).strip()
    elif m.group(1) in 'qQ1':  # question
      finish_or_add(0, m.group(2))
    elif m.group(1) in 'aA2': # answer
      finish_or_add(1, m.group(2))
    elif m.group(1) == '3':
      finish_or_add(2, m.group(2))
    elif m.group(1) == '4':
      finish_or_add(3, m.group(2))
    elif m.group(1) == '5':
      finish_or_add(4, m.group(2))
    elif m.group(1) == '6':
      finish_or_add(5, m.group(2))
    else:
      assert 0
  else:  # tab-delimited file
    print 'tab-delimited'
    cur_item = l.split('\t')     
    cur_cat = ''
    if len(cur_item) > 6:
      cur_cat = cur_item.pop(6)
      assert len(cur_item) <= 6
    finish_item()
      
# final finish to add the last record
finish_item()

      
# now create output file structure
catnums = {}
for i in all_items:
  nug = catnums.get(i.cat, 0)
  catnums[i.cat] = nug + 1
  nugname = os.path.join(sys.argv[2], i.cat, '%05d.nug' % nug)
  os.makedirs(nugname)
  f = file(os.path.join(nugname, 'q.txt'), 'w')
  print >>f, i.items[0]
  printfield = False
  for field in i.items[2:6]:
    if field != '':
      printfield = True
      break
  if printfield:
    for field in i.items[2:6]:
      print >>f, field
  f = file(os.path.join(nugname, 'a.txt'), 'w')
  print >>f, i.items[1]
        
    
  
